#!/usr/bin/env python

from rankme import rankme
import es, usermsg, popuplib

def load():
    global hitsetting
    hitsetting = rankme.addUserSetting('hit_message', 'togglehurt', toggleHit, 1, rankme.addon_path + '/modules/hitmessage/data.db')
    announce = rankme.addAnnounce('togglehurt', 3, '#greenrankME: #defaultType #teamtogglehurt#default to change the display of your hits.')
    hitsetting.load()

def toggleHit(userid, args, setting):
    hit = popuplib.create('togglehit')
    hit.addline('Toggle Hit Messages')
    hit.addline(' ')
    hit.addline('Display Setting:')
    hit.addline('->1. Chatbox [%s]' % 'ON' if setting == 1 else '->1. Chatbox [OFF]')
    hit.addline('->2. Console [%s]' % 'ON' if setting == 2 else '->2. Console [OFF]')
    hit.addline('->3. Hudhint [%s]' % 'ON' if setting == 3 else '->3. Hudhint [OFF]')
    hit.addline('->4. Turn Off')
    hit.addline(' ')
    hit.addline('0. Close')
    
    hit.menuselect = selectToggle
    hit.send(userid)
    
def selectToggle(userid, choice, popupid):
    if choice == 1:
        hitsetting.change(rankme.getPlayer(userid).uniqueid, 1)
    elif choice == 2:
        hitsetting.change(rankme.getPlayer(userid).uniqueid, 2)
    elif choice == 3:
        hitsetting.change(rankme.getPlayer(userid).uniqueid, 3)
    elif choice == 4:
        hitsetting.change(rankme.getPlayer(userid).uniqueid, 0)
    if choice in (1, 2, 3, 4): toggleHit(userid, None, rankme.usersettings['hit_message'].get(rankme.getPlayer(userid).uniqueid))

def player_hurt(ev):
    if rankme.settings.do_bots_count == 0 and es.isbot(ev['attacker']):
        return
    
    if rankme.settings.do_bots_count == 0 and es.isbot(ev['userid']):
        return
    
    userid = int(ev['attacker'])
    hit = int(ev['hitgroup'])
    damage = int(ev['dmg_health'])
    index = rankme.getPlayer(int(ev['userid'])).get('index')
    convert = {1 : 'head', 2 : 'chest', 3 : 'stomach', 4 : 'left arm', 5 : 'right arm', 6 : 'left leg', 7 : 'right leg'}
    if rankme.settings.message_hurt_events:
        if hit > 0:
            
            userid = rankme.getPlayer(userid).uniqueid
            if hitsetting.get(userid) == 1:
                rankme.tell(ev['attacker'], index, 'player hurt', {'victim' : es.getplayername(ev['userid']), 'hitbox' : convert[hit], 'damage' : damage})
            elif hitsetting.get(userid) == 2:
                usermsg.echo(ev['attacker'], 'rankME: You hurt player %s in his %s with a damage of %s.' % (es.getplayername(ev['userid']), convert[hit], damage))
            elif hitsetting.get(userid) == 3:
                usermsg.hudhint(ev['attacker'], 'rankME: You hurt player %s\n in his %s with a damage of %s' % (es.getplayername(ev['userid']), convert[hit], damage))